/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PayableOverrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../../common";

export declare namespace CoinMintPlugin {
  export type CreateTokenDataStruct = {
    name: PromiseOrValue<string>;
    symbol: PromiseOrValue<string>;
    decimals: PromiseOrValue<BigNumberish>;
    initSupply: PromiseOrValue<BigNumberish>;
    claimSupply: PromiseOrValue<BigNumberish>;
    claimLimitPreAddress: PromiseOrValue<BigNumberish>;
    claimStartTime: PromiseOrValue<BigNumberish>;
    claimEndTime: PromiseOrValue<BigNumberish>;
    claimPriceRange: PromiseOrValue<BigNumberish>[];
    claimPrice: PromiseOrValue<BigNumberish>[];
    claimPayCurrencyAddress: PromiseOrValue<string>;
    communityIds: PromiseOrValue<BigNumberish>[];
  };

  export type CreateTokenDataStructOutput = [
    string,
    string,
    number,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber[],
    BigNumber[],
    string,
    BigNumber[]
  ] & {
    name: string;
    symbol: string;
    decimals: number;
    initSupply: BigNumber;
    claimSupply: BigNumber;
    claimLimitPreAddress: BigNumber;
    claimStartTime: BigNumber;
    claimEndTime: BigNumber;
    claimPriceRange: BigNumber[];
    claimPrice: BigNumber[];
    claimPayCurrencyAddress: string;
    communityIds: BigNumber[];
  };

  export type CoinDataStruct = {
    owner: PromiseOrValue<string>;
    claimSupply: PromiseOrValue<BigNumberish>;
    claimLimitPreAddress: PromiseOrValue<BigNumberish>;
    claimStartTime: PromiseOrValue<BigNumberish>;
    claimEndTime: PromiseOrValue<BigNumberish>;
    claimPriceRange: PromiseOrValue<BigNumberish>[];
    claimPrice: PromiseOrValue<BigNumberish>[];
    claimPayCurrencyAddress: PromiseOrValue<string>;
    claimAddressCount: PromiseOrValue<BigNumberish>;
    claimedAmount: PromiseOrValue<BigNumberish>;
  };

  export type CoinDataStructOutput = [
    string,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber[],
    BigNumber[],
    string,
    BigNumber,
    BigNumber
  ] & {
    owner: string;
    claimSupply: BigNumber;
    claimLimitPreAddress: BigNumber;
    claimStartTime: BigNumber;
    claimEndTime: BigNumber;
    claimPriceRange: BigNumber[];
    claimPrice: BigNumber[];
    claimPayCurrencyAddress: string;
    claimAddressCount: BigNumber;
    claimedAmount: BigNumber;
  };
}

export interface CoinMintPluginInterface extends utils.Interface {
  functions: {
    "_init()": FunctionFragment;
    "checkTransaction(address,address,address,uint256)": FunctionFragment;
    "claimToken(address,uint256,uint256)": FunctionFragment;
    "createToken((string,string,uint8,uint256,uint256,uint256,uint256,uint256,uint256[],uint256[],address,uint256[]))": FunctionFragment;
    "getCoinData(address)": FunctionFragment;
    "isClaimed(address,address[])": FunctionFragment;
    "tokenImpl()": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "_init"
      | "checkTransaction"
      | "claimToken"
      | "createToken"
      | "getCoinData"
      | "isClaimed"
      | "tokenImpl"
  ): FunctionFragment;

  encodeFunctionData(functionFragment: "_init", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "checkTransaction",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "claimToken",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "createToken",
    values: [CoinMintPlugin.CreateTokenDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "getCoinData",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "isClaimed",
    values: [PromiseOrValue<string>, PromiseOrValue<string>[]]
  ): string;
  encodeFunctionData(functionFragment: "tokenImpl", values?: undefined): string;

  decodeFunctionResult(functionFragment: "_init", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "checkTransaction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "claimToken", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "createToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getCoinData",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "isClaimed", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "tokenImpl", data: BytesLike): Result;

  events: {
    "CoinClaim(address,address,uint256,uint256,uint256,uint256)": EventFragment;
    "CoinCreate(address,address,tuple)": EventFragment;
    "Initialized(uint8)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "CoinClaim"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CoinCreate"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Initialized"): EventFragment;
}

export interface CoinClaimEventObject {
  tokenAddress: string;
  claimer: string;
  communityId: BigNumber;
  amount: BigNumber;
  claimedAmount: BigNumber;
  claimedAddressCount: BigNumber;
}
export type CoinClaimEvent = TypedEvent<
  [string, string, BigNumber, BigNumber, BigNumber, BigNumber],
  CoinClaimEventObject
>;

export type CoinClaimEventFilter = TypedEventFilter<CoinClaimEvent>;

export interface CoinCreateEventObject {
  tokenAddress: string;
  owner: string;
  data: CoinMintPlugin.CreateTokenDataStructOutput;
}
export type CoinCreateEvent = TypedEvent<
  [string, string, CoinMintPlugin.CreateTokenDataStructOutput],
  CoinCreateEventObject
>;

export type CoinCreateEventFilter = TypedEventFilter<CoinCreateEvent>;

export interface InitializedEventObject {
  version: number;
}
export type InitializedEvent = TypedEvent<[number], InitializedEventObject>;

export type InitializedEventFilter = TypedEventFilter<InitializedEvent>;

export interface CoinMintPlugin extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: CoinMintPluginInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    _init(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    checkTransaction(
      tokenAddress: PromiseOrValue<string>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[void]>;

    claimToken(
      token: PromiseOrValue<string>,
      communityId: PromiseOrValue<BigNumberish>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    createToken(
      data: CoinMintPlugin.CreateTokenDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    getCoinData(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<
      [
        CoinMintPlugin.CoinDataStructOutput,
        string,
        string,
        number,
        BigNumber
      ] & {
        coinData: CoinMintPlugin.CoinDataStructOutput;
        name: string;
        symbol: string;
        decimals: number;
        totalSupply: BigNumber;
      }
    >;

    isClaimed(
      addr: PromiseOrValue<string>,
      tokenAddress: PromiseOrValue<string>[],
      overrides?: CallOverrides
    ): Promise<[boolean[]] & { res: boolean[] }>;

    tokenImpl(overrides?: CallOverrides): Promise<[string]>;
  };

  _init(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  checkTransaction(
    tokenAddress: PromiseOrValue<string>,
    from: PromiseOrValue<string>,
    to: PromiseOrValue<string>,
    amount: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<void>;

  claimToken(
    token: PromiseOrValue<string>,
    communityId: PromiseOrValue<BigNumberish>,
    amount: PromiseOrValue<BigNumberish>,
    overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  createToken(
    data: CoinMintPlugin.CreateTokenDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  getCoinData(
    token: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<
    [CoinMintPlugin.CoinDataStructOutput, string, string, number, BigNumber] & {
      coinData: CoinMintPlugin.CoinDataStructOutput;
      name: string;
      symbol: string;
      decimals: number;
      totalSupply: BigNumber;
    }
  >;

  isClaimed(
    addr: PromiseOrValue<string>,
    tokenAddress: PromiseOrValue<string>[],
    overrides?: CallOverrides
  ): Promise<boolean[]>;

  tokenImpl(overrides?: CallOverrides): Promise<string>;

  callStatic: {
    _init(overrides?: CallOverrides): Promise<void>;

    checkTransaction(
      tokenAddress: PromiseOrValue<string>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<void>;

    claimToken(
      token: PromiseOrValue<string>,
      communityId: PromiseOrValue<BigNumberish>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<void>;

    createToken(
      data: CoinMintPlugin.CreateTokenDataStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    getCoinData(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<
      [
        CoinMintPlugin.CoinDataStructOutput,
        string,
        string,
        number,
        BigNumber
      ] & {
        coinData: CoinMintPlugin.CoinDataStructOutput;
        name: string;
        symbol: string;
        decimals: number;
        totalSupply: BigNumber;
      }
    >;

    isClaimed(
      addr: PromiseOrValue<string>,
      tokenAddress: PromiseOrValue<string>[],
      overrides?: CallOverrides
    ): Promise<boolean[]>;

    tokenImpl(overrides?: CallOverrides): Promise<string>;
  };

  filters: {
    "CoinClaim(address,address,uint256,uint256,uint256,uint256)"(
      tokenAddress?: PromiseOrValue<string> | null,
      claimer?: PromiseOrValue<string> | null,
      communityId?: null,
      amount?: null,
      claimedAmount?: null,
      claimedAddressCount?: null
    ): CoinClaimEventFilter;
    CoinClaim(
      tokenAddress?: PromiseOrValue<string> | null,
      claimer?: PromiseOrValue<string> | null,
      communityId?: null,
      amount?: null,
      claimedAmount?: null,
      claimedAddressCount?: null
    ): CoinClaimEventFilter;

    "CoinCreate(address,address,tuple)"(
      tokenAddress?: PromiseOrValue<string> | null,
      owner?: PromiseOrValue<string> | null,
      data?: null
    ): CoinCreateEventFilter;
    CoinCreate(
      tokenAddress?: PromiseOrValue<string> | null,
      owner?: PromiseOrValue<string> | null,
      data?: null
    ): CoinCreateEventFilter;

    "Initialized(uint8)"(version?: null): InitializedEventFilter;
    Initialized(version?: null): InitializedEventFilter;
  };

  estimateGas: {
    _init(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    checkTransaction(
      tokenAddress: PromiseOrValue<string>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    claimToken(
      token: PromiseOrValue<string>,
      communityId: PromiseOrValue<BigNumberish>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    createToken(
      data: CoinMintPlugin.CreateTokenDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    getCoinData(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    isClaimed(
      addr: PromiseOrValue<string>,
      tokenAddress: PromiseOrValue<string>[],
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    tokenImpl(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    _init(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    checkTransaction(
      tokenAddress: PromiseOrValue<string>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    claimToken(
      token: PromiseOrValue<string>,
      communityId: PromiseOrValue<BigNumberish>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    createToken(
      data: CoinMintPlugin.CreateTokenDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    getCoinData(
      token: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isClaimed(
      addr: PromiseOrValue<string>,
      tokenAddress: PromiseOrValue<string>[],
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    tokenImpl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
